

#include <avr/io.h>
#include "ADCPeripheral.H"


using namespace std;
using namespace avelino;


void ADCPeripheral::init() {
	// Vref = 5v, input A0 on Arduino Leonardo = ADC7
	ADMUX = (0x01 << 6) | (0x01 << 5) | 0x07;
	// low speed, auto-trigger = free running
	ADCSRB = 0;
	// enable ADC, start conversion, auto-trigger on, prescaler = 128
	ADCSRA = (0x01 << 7) | (0x01 << 6) | (0x01 << 5) | 0x07;
}


uint8_t ADCPeripheral::getValue() {
	return ADCH;
}


uint8_t ADCPeripheral::getPercent() {
	return ((((uint16_t) ADCH) * 50) / 255);
}

