

#ifndef  __MIDIFILTER_H__
#define  __MIDIFILTER_H__


#include <stdint.h>
#include <stdlib.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		class MIDISender {
			public:
				virtual void sendByte(uint8_t byte) = 0;
		};

		class MIDIFilter {
			protected:
				MIDISender *sender;
			public:
				MIDIFilter() : sender(NULL) { };
				void init(MIDISender &sender) { this->sender = &sender; };
				virtual void byteReceived(uint8_t byte) = 0;
				virtual void run() = 0;
		};
	}
}


#endif  // __MIDIFILTER_H__
