

#ifndef  __MIDISHUFFLER_H__
#define  __MIDISHUFFLER_H__


#include <stdint.h>
#include "StaticQueue.H"
#include "TimeCounter.H"
#include "MIDIFilter.H"
#include "PercentProvider.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class DelayedMIDIByte {
			public:
				int32_t t;
				uint8_t byte;
				DelayedMIDIByte(int32_t t = 0, uint8_t byte = 0) : t(t), byte(byte) { };
		};

		class MIDIShuffler : public MIDIFilter {
			protected:
				StaticQueue<uint8_t, 256> rxQueue;
				StaticQueue<DelayedMIDIByte, 64> delayQueue;
				static const uint8_t STATUS_WAIT_START_MIDI_CLOCK = 1;
				static const uint8_t STATUS_WAIT_FIRST_MIDI_CLOCK = 2;
				static const uint8_t STATUS_WAIT_MIDI_CLOCK       = 3;
				uint8_t status;
				static const uint16_t CLOCK_PER_SIXTEENTH_NOTE = 6;
				uint16_t clockCounter;
				uint8_t sixteenthNoteIndex;
				TimeCounter *timeCounter;
				int32_t sixteenthNoteLength;
				int32_t reducedLength;
				int32_t getDelayedInstant(int32_t sourceInstant);
				bool byPass;
				PercentProvider *percentProvider;
				void processRxByte(uint8_t byte);
			public:
				virtual void byteReceived(uint8_t byte);
				virtual void init(MIDISender &sender, PercentProvider &percentProvider, TimeCounter &timeCounter);
				virtual void run();
				void setByPass(bool byPass);
		};
	}
}


#endif  // __MIDISHUFFLER_H__
