

#ifndef  __STATICQUEUE_H__
#define  __STATICQUEUE_H__


extern "C++" {
	namespace avelino {
		using namespace std;

		template <typename T, int32_t N>
		class StaticQueue {
			public:
				T data[N];
				int32_t head, tail;
				StaticQueue() {
					this->clear();
				};
				bool hasElements() {
					return ((this->head != this->tail) ? true : false);
				};
				void clear() {
					this->head = this->tail = 0;
				};
				void push(T v) {
					this->data[this->tail] = v;
					this->tail = (this->tail + 1) % N;
				};
				T getHead() {
					T ret;
					if (this->tail != this->head)
						ret = this->data[this->head];
					return ret;
				};
				void pop() {
					if (this->tail != this->head)
						this->head = (this->head + 1) % N;
				};
		};
	}
}


#endif  // __STATICQUEUE_H__
