

#include <avr/io.h>
#include <avr/interrupt.h>
#include "Timer1TimeCounter.H"


using namespace std;
using namespace avelino;


void Timer1TimeCounter::start() {
	TCCR1B = 5; // clock source = 16000000 / 1024 = 15625 Hz
	uint8_t sreg = SREG;
	cli();
	TCNT1 = 0;  // counter = 0
	SREG = sreg;
}


void Timer1TimeCounter::stop() {
	TCCR1B = 0; // clock source = stoped
}


int32_t Timer1TimeCounter::getValue() {
	uint8_t sreg = SREG;
	cli();
	int32_t ret = (int32_t) TCNT1;
	SREG = sreg;
	return ret;
}

