

#include <avr/io.h>
#include "UARTPeripheral.H"


using namespace std;
using namespace avelino;


void UARTPeripheral::init() {
	const uint16_t MIDI_BAUD = 31250;
	const uint16_t BAUD = ((uint16_t) (16000000ULL / (16ULL * MIDI_BAUD))) - 1;
	UBRR1H = (uint8_t) (BAUD >> 8);
	UBRR1L = (uint8_t) (BAUD & 0xFF);
	UCSR1B = 0x18;
	UCSR1C = 0x06;
}


bool UARTPeripheral::rxReady() {
	return ((UCSR1A & 0x80) ? true : false);
}


uint8_t UARTPeripheral::read() {
	return (uint8_t) UDR1;
}


bool UARTPeripheral::txReady() {
	return ((UCSR1A & 0x20) ? true : false);
}


void UARTPeripheral::write(uint8_t byte) {
	UDR1 = byte;
}


void UARTPeripheral::sendByte(uint8_t byte) {
	while (!this->txReady())
		;
	this->write(byte);
}

