/*
 * vim: ts=4 nobackup
 */


#include <stdint.h>
#include <avr/io.h>
#include <util/delay.h>
#include "MIDIFilter.H"
#include "MIDIShuffler.H"
#include "Timer1TimeCounter.H"
#include "ADCPeripheral.H"
#include "UARTPeripheral.H"


using namespace std;
using namespace avelino;


int main() {
	UARTPeripheral uart;
	MIDIShuffler shuffler;
	Timer1TimeCounter timeCounter;
	ADCPeripheral adc;
	uart.init();
	adc.init();
	shuffler.init(uart, adc, timeCounter);
	while (true) {
		if (uart.rxReady()) {
			uint8_t byte = uart.read();
			shuffler.byteReceived(byte);
		}
		shuffler.run();
	}
	return 0;
}
